################################################################################
#    PERL Session 1.0.                                                         #
#    Copyright (C) 2002 Luca Bertoncello                                       #
#    Waltherstrae, 11D - 01067 Dresden Deutschland                            #
#    E-Mail: lucabert@lucabert.com                                             #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; version 2 of the License.                   #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; if not, write to the Free Software               #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
################################################################################

$::sessionPath = '/usr/tmp';

sub newSession
{
  my($sessionId, $l, $i1, $i2, $i3, $o1, $o2, $o3, $fileInUso);

  srand(time|$$);
  $fileInUso = 1;
  while($fileInUso == 1)
    {
      $sessionId = '';
      for($l = 0; $l < 8; $l++)
        {
          $i1 = rand(24) + 65;
          $o1 = int($i1);
          $i2 = rand(24) + 97;
          $o2 = int($i2);
          $i3 = rand(10) + 48;
          $o3 = int($i3);
          $sessionId .= chr($o1).chr($o2).chr($o3);
        }

      open(SESSION, $::sessionPath."/session_$sessionId") || { $fileInUso = 0 };
      if($fileInUso == 1)
        {
          close(SESSION);
        }
    }

  open(SESSION, "> ".$::sessionPath."/session_$sessionId");
  close(SESSION);

  return $sessionId;
}

sub deleteSession
{
  my($sid) = @_;

  system("rm -f ".$::sessionPath."/session_$sid");
}

sub saveDataToSession
{
  my($sid) = @_;
  my($varName, $varValue);

  open(SESSION, "> ".$::sessionPath."/session_$sid");
  for $varName (sort keys %session)
    {
      $varValue             = $session{$varName};
      print SESSION "$varName|".escapeString($varValue)."\n";
    }
  close(SESSION);
}

sub readDataFromSession
{
  my($sid) = @_;
  my(@lines, $varName, $varValue);

  open(SESSION, $::sessionPath."/session_$sid") || die("session '$sid' closed!!");
  @lines                    = <SESSION>;
  close(SESSION);

  foreach $line (@lines)
    {
      $line                 =~ s/[\n\r]//g;
      ($varName, $varValue) = split(/\|/, $line);
      $session{$varName}    = unescapeString($varValue);
    }
}

sub escapeString
{
  my($str) = @_;
  my($escapedStr, $strLength, $i);
  local ($_);

  $escapedStr = "";
  $strLength = length( $str );
  foreach $i (0..($strLength - 1))
    {
      $_ = substr($str, $i, 1);
      if (/\W/)
        {
          $escapedStr .= "%".sprintf("%02lx", ord($_));
        }
      else
        {
          $escapedStr .= $_;
        }
    }

  return($escapedStr);
}

sub unescapeString
{
  my($v, @lista, $l);
  local($_) = $_[0] ;

  tr/+/ / ;
  @lista =  /%([0-9A-Fa-f][0-9A-Fa-f])/g ;
  foreach $l (@lista)
    {
      if($l !~ /25/)
        {
          $v = chr(hex($l));
          s/%$l/$v/ ;
        }
    }
  s/%25/%/g ;

  return $_;
}

##############################
# END
##############################

return 1;
